--Main LUA module global shortcuts
lg = love.graphics
la = love.audio
lk = love.keyboard

--Required Files ( Some files require more ) 
require "AnAL.lua" -- Animations And Love --- by bartbes.
require "player.lua"  -- singleton
require "rock.lua"  -- made from Class.lua
require "mouseHelper.lua" -- singleton ( Shows user input.) 


-- game and world elements
world = {} -- contains singletonGame elements. UI, The like. 
rocks = {}  -- the future of this table will be to use a function to create an object in the indexes. rocks[i] = newRock(<params>)


-- BG elements ( can be animated in love.draw() ) 
sky = lg.newImage("bgSky.png")
walls = lg.newImage("bgCanyon.png")
ground = lg.newImage("bgFloor.png")

groundLevel = 475
grav = 10
score = 0


xanDbg = "debug not set"

function love.load()

-- the game will start in this load function. The objects will run the show from then on. 
table.insert(world,xan) 
table.insert(world,mouseHelper)

-- load love types ( font,color,audio...) 
gtxt = love.graphics.newFont("ka1.ttf",15)
gtxtB = love.graphics.newFont("ka1.ttf",40)
gtxtC = love.graphics.newFont("ka1.ttf",30)


--Play BGM
---[[
bgm = love.audio.newSource("sounds/beginLoop.ogg","stream") -- this is for large audio files. 
la.play(bgm) 
bgm:setLooping(true)
bgm:setVolume(0.8)
--]]

--SFX
slide = la.newSource("sounds/rockPush.mp3", "static") -- static would be good for this because it's small. We can keep it in RAM> 


--DBG
dbg = "notSet" -- default variable just in case we nuke it along the way. 
some = "notYet"
 

end

alpha = 0 
other = 0 

-- general easing formula. (var/max)*rate

function love.update(dt)


	
	alpha = range(alpha,0,255,15)

	other = range(other,50,255,1)
	
	for n, b in pairs(world) do 
		b:update(dt)
	end
	
	for n, b in pairs(rocks) do
		b:update(dt)
	end
	

-- update the debug string
	
	if xan.sideBlock then
		dbg = "sideBlocked"
	elseif xan.footBlock then
		dbg = "footBlocked"
	elseif xan.canJump == false then
		dbg = "cantJump"
	elseif xan.headBlock then
		dbg = "headBlock"
	else
		dbg = "nope"
	end

end



function love.draw()
 
	
	love.graphics.setColor(100,100,100,alphaX) -- kinda grey so we can read the DBG text 
	lg.draw(sky,0,0) 
	
	love.graphics.setColor(alpha,255,255,255) -- WHITE - for the blending mode. Changes the shade of what's drawn.
	lg.draw(walls,0,0) 
	lg.draw(ground,0,0) 
			
	--SCORE AREA
	love.graphics.setColor(150,15,10,255)--RED	
	love.graphics.setFont(gtxtB)
	lg.print("SCORE - "..score, 10, 45) 
	
	love.graphics.setFont(gtxtC)
	lg.print("blkd - "..dbg, 10, 85)
	
--Back To White!
	love.graphics.setColor(255,255,255,255)
	
	for n, b in pairs(rocks) do -- index(n)  and Value (b)
		b:draw() -- we tell the xan instance to draw.. so this goes to xan:draw()
	end
	
	for n, b in pairs(world) do -- index(n)  and Value (b)
		b:draw() -- we tell the xan instance to draw.. so this goes to xan:draw()
	end	
	
	-- draw the Debug txt 
	
	if xanDbg then 
	
	love.graphics.setFont(gtxt)
	lg.print( "jumpSpeed - "..xan.jspd -- string concat. we can plug in different variables. 
			.."\n xan_y - "..xan.y
			.."\n p_state - "..xan.state
			.."\n Alpha - "..alpha
			.."\n Other - "..other,
			10, 115) --x,y
	
	end

end

local incDec = true -- start on the rise! 
vars = {}
-- function for interpolating. 
function range(var,mn,mx,rate)
	

	
	if incDec then 
		
		var = var + rate 

	else
	
		var = var - rate 
		
	end
	
	if var >= mx then 
		incDec = false
		var = mx
	end 
	
	if var <= mn then
		incDec = true
		var = mn
	end
	
	return var

end

function addPoints(val)
	
	score = score + val -- value comes from the rock in the list. 
	
end


function love.keypressed( key )

   if key == "escape" then
      
	  love.event.push("q")
	  
   elseif key == " " then 
   
		--newRock(x,y,weight)	
		table.insert(rocks,newRock(xan.x + 100,50,1))
		
   end
   
end

function checkHit ( a, b ) -- AABB collision. 
	
	-- Boundaries for 'a'
	local aRight 	= a.x + a.drawVars.xo
	local aLeft 	= a.x - a.drawVars.xo
	local aTop		= a.y - a.drawVars.yo
	local aBottom	= a.y -- the origin is offset by the size of the image used. So y is always the bottom. 
	
	-- Bounds for 'b'
	local bRight 	= b.x + b.drawVars.xo
	local bLeft 	= b.x - b.drawVars.xo
	local bTop		= b.y - b.drawVars.yo
	local bBottom	= b.y -- the origin is offset by the size of the image used. So y is always the bottom. 

	-- the AABB part:
	if  aRight < bLeft or
		aLeft > bRight or
		aBottom < bTop or
		aTop > bBottom then
		return false
	else
		return true
	end
	
end