--rock Class. Based on class file. 

require("class.lua")

local boulder = lg.newImage("rock.png")


newRock = class(function(obj, x, y, weight) -- this is the definition of the function that will create the rocks. 

	-- positioning 
	obj.x = x
	obj.y = y
	obj.weight = weight
	obj.state = "rest" -- this is for fun physics. 
	
	-- game logic variables.
	obj.value = 50 * weight -- bigger rocks. There is more to the point multiplier system. 
	obj.sSpeed = weight * 10
	obj.states = {"slide","rest","sleep","slam","grab","fall"} -- fall is when the rock is affected by grab
	
	
	-- change art based on weight.
	if obj.weight == 1 then
		obj.img = boulder 
	end
	
	
	obj.drawVars = {
		x = obj.x,
		y = obj.y,
		xo = obj.img:getWidth()/2, -- offset is rather important to this system.
		yo = obj.img:getHeight(),
		sx = 1,
		sy = 1,
		rot = 0, -- we can make these more dynamic later. 
	
	}
	

end)


function newRock:update(dt)

	local frict = 1
	local top = self.y - self.img:getHeight()
	
	self:updateCollision()
	
	
	if checkHit(xan,self) then
		xan.sideBlock = true
	end
	
	
	-- Rock State Switch. 
	if checkHit(xan,self) and xan.state == "grab" then
	
		self.state = "grab"
		
	elseif checkHit(xan,self) and xan.state == "idle" then
	
		self.state = "rest"
	
	elseif xan.state == "kick" and checkHit(xan,self) then
		
		self.state = "slide"
		
	elseif checkHit(xan,self) and self.state == "fall" then
	
		 self.state = "sleep"
		 
	elseif checkHit(xan,self) == false and self.state == "sleep" then
	
		self.state = "rest" 
	
	end
	
	if self.state == "rest"  and self.y < groundLevel and checkHit(xan,self)== false then
		
		self.state = "fall"
		
	end

	-- rock state manager. all possible behaviors should rest in this switch. Each rock can only be in one state at a time.
	if self.state == "slide" then
		self:Slide() -- this function is right. But isn't called in the right way. REMEMBER THE SYNTAX:DUDE()
	end
		
	--keep the self on stage. 
	local edgeRight = self.x + self.drawVars.xo
	local edgeLeft = self.x - self.drawVars.xo
	
	-- update self gravity. 
	if self.state == "fall" then
		self.y = self.y + grav
		
		-- keep the gruoundLevel In mind. 
		if self.y >= groundLevel then
			self.state = "rest"
			self.y = groundLevel
		end
	end 
	
	-- we need a function to separate the rocks. And to organize them. 
	self:keepSpacing()
	
	
end 

function newRock:draw()

	lg.draw(self.img, self.x, self.y, self.drawVars.rot,self.drawVars.sx, self.drawVars.sy, self.drawVars.xo, self.drawVars.yo)
	--shape at self origin
	lg.circle("fill",self.x, self.y, 5)
	
	-- draw the state on the rock
	lg.setFont(gtxt)
	lg.print(self.state, self.x - self.drawVars.xo, self.y-32) 
	
end

function newRock:updateCollision()

	-- hit the borders of the stage. ( there should be space enough for 7x7 rocks)
	
	-- hit the player 
	
	-- hit other rocks



end

function newRock:Slide()

		la.play(slide)
		
		-- if self.state == "slide" then we want to move the rock. 
		self.x = self.x + (self.sSpeed * xan.drawVars.sx)
		
		for i,v in pairs(rocks) do
			if checkHit(self,rocks[i]) and self ~= rocks[i] then
				self.state = "rest"
			end
		end

end

function newRock:Slam() -- will this get rid of that nil?
		
		local xGrip = xan.x * xan.drawVars.sx + 32
		local xGrip = xan.y * xan.drawVars.sx + 45
		
		self.x = xGrip
		self.y = yGrip
		-- add to rock list. Maybe this can lead into an overflow mechanic. If you don't push hard enough the rocks will not fall. It's a good place to evaluate the state of the player. 
		self.state = "slam"
		
		-- the main fill will be the game state machine so score will be global.
		--addPoints(self.value)
		
end

function newRock:keepSpacing()

	-- the goal here is to make the rocks have a look at eachother and separate themselves. 
	
	--keep the self on stage. we can use the rock edges to hit other rocks. 
	local edgeRight = self.x + self.drawVars.xo
	local edgeLeft = self.x - self.drawVars.xo
	local edgeUp = self.y - self.drawVars.yo
	local edgeDown = self.y -- we adjust the origin to the bottom. Everything has a foot in this game. 
	
	-- and we can set a cell size and a spread speed anti friction if you will.  Part of what makes games fun. 
	local spread = 1 -- pace at which we punish the rocks. 
	local dist = 32 -- the space that should be between rock origins. 
		
	
	if edgeRight + self.sSpeed > lg.getWidth()  then -- hits edge of the screen. 
		self.x = lg.getWidth() - self.drawVars.xo - 32
		self.state = "rest"
	elseif edgeLeft - self.sSpeed < 0 then -- hits edge of the screen. -- lets leave some room for sliding space. 
		self.x = self.drawVars.xo + 32
		self.state = "rest"
	end
	
	
	-- Keep the rocks on the stage. 
	if edgeRight + self.sSpeed > lg.getWidth() then -- hits edge of the screen. 
			self.x = lg.getWidth() - self.drawVars.xo
			self.state = "rest"
	elseif edgeLeft - self.sSpeed < 0 then -- hits edge of the screen. 
			self.x = self.drawVars.xo
			self.state = "rest"
	end

	
	-- hit xan in the for. Become a good ground. ( the top rock will be able to grab. ) 
	if xan.sideBlock == false and xan.y >= edgeUp and checkHit(xan, self) then 
		xan.y = edgeUp
		xan.footBlock = true
		xan.canJump = true
		xan.jump = false
		xan.state = "idle"
	end
	
	
	for i,v in pairs(rocks) do -- hits other rocks
			
		-- also make a version for the instanced rock

		-- we only assign the other Rock values to the non self. 
		local rockRight = rocks[i].x + rocks[i].drawVars.xo
		local rockLeft = rocks[i].x - rocks[i].drawVars.xo
		local rockUp = rocks[i].y - rocks[i].drawVars.yo
		local rockDown = rocks[i].y 	
		
		
		if rocks[i] ~= self then 

			if checkHit(self,rocks[i]) then
			
				if self.x <= rocks[i].x and self.y > rockUp then -- if the self is on the left side of the rock when they collide. 
					
					repeat 
					self.x = self.x - spread
					until
					checkHit(self,rocks[i]) == false 
					
				elseif self.x >= rocks[i].x and self.y > rockUp then -- is to the right side. not on top. 
					
					repeat 
					self.x = self.x + spread
					until
					checkHit(self,rocks[i]) == false 
					
				elseif self.y <= rocks[i].y then

					repeat 
					self.y = self.y - spread
					until
					checkHit(self,rocks[i]) == false 
					
				end
				
			end		
			
		end
		
	end 

end 